<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          <i class="fa fa-globe"></i>{{'object.ssl.title' | translate}}
          <span class="float-right">
            <button (click)="addSsl()" class="btn btn-block btn-primary"
                    [disabled]="isEditing">{{'common.add' | translate}}</button></span>
        </div>
        <div class="card-body">
          <div class="row justify-content-between mb-2">
            <div class="col-6">
              <span class="float-left pr-3 show-entity-per-page-label">{{'common.show' | translate}}</span>
              <select (change)="onSearch()" [(ngModel)]="paging.limit" class="form-control float-left" [disabled]="isEditing"
                      style="max-width: 70px">
                <option *ngFor="let i of PAGING_PER_PAGE" value="{{i.value}}">{{i.label}}</option>
              </select>
            </div>
            <div class="col-2">
              <div class="input-group float-right">
                <input [(ngModel)]="keywordSearch" type="text" class="form-control"
                       placeholder="{{'common.search' | translate}}">
                <div class="input-group-append">
                  <button (click)="onSearch()" class="btn btn-dark" type="button"
                          [disabled]="isEditing">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>

          <form [formGroup]="sslFormGroup">
            <table class="table table-bordered table-sort-icon">
              <thead>
              <tr [disabled]="isEditing" appSort [(orderBy)]="order.orderBy" [(orderType)]="order.orderType"
                  (orderChange)="changeOder($event)">
                <th appSortBy="ssl_name" class="text-center">{{'object.ssl.name' | translate}}
                  <fa-icon></fa-icon>
                </th>
                <th appSortBy="ssl_description" class="text-center">{{'object.ssl.description' | translate}}
                  <fa-icon></fa-icon>
                </th>
                <th class="text-center">{{'object.ssl.key_cert' | translate}}</th>
                <th class="text-center">{{'common.action' | translate}}</th>
              </tr>
              </thead>
              <tbody formArrayName="data" *ngFor="let ssl of getFormData.controls; let i=index">
              <tr [formGroupName]="i">
                <td>
                  <span *ngIf="!ssl.get('is_update').value">
                    {{ssl.get('ssl_name').value}}
                  </span>
                  <div *ngIf="ssl.get('is_update').value">
                    <input type="text" class="form-control" formControlName="ssl_name"
                           placeholder="{{'object.ssl.name' | translate}}">
                    <span class="text-danger"
                          *ngIf="ssl.get('ssl_name').touched && ssl.get('ssl_name').invalid">{{'error.validate.input_required' | translate}}</span>
                  </div>
                </td>
                <td>
                  <span *ngIf="!ssl.get('is_update').value">
                    {{ssl.get('ssl_description').value}}
                  </span>
                  <div *ngIf="ssl.get('is_update').value">
                    <input type="text" class="form-control" formControlName="ssl_description"
                           placeholder="{{'object.ssl.description' | translate}}">
                    <span class="text-danger"
                          *ngIf="ssl.get('ssl_description').touched && ssl.get('ssl_description').invalid">{{'error.validate.input_required' | translate}}</span>
                  </div>
                </td>
                <td class="text-center">
                  <div *ngIf="!ssl.get('is_update').value">
                    <span style="cursor: pointer" (click)="openViewCert(i, ssl.value)">
                    <i style="font-size: 20px"
                       [class]="ssl.get('is_show_cert').value? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i>
                    </span>
                    <div class="_tooltip tooltip__initiator text-left" *ngIf="ssl.get('is_show_cert').value">
                      <div class="tooltip__item bg-white left-50">
                        <div *ngIf="selectedSSL && selectedSSL.ssl_key && selectedSSL.ssl_key"
                             class="container cert-detail">
                          <div class="row">
                            <div class="col-2">{{'object.ssl.ssl_key' | translate}}</div>
                            <div class="col-10">{{selectedSSL.ssl_key}}</div>
                          </div>
                          <hr>
                          <div class="row">
                            <div class="col-2">{{'object.ssl.ssl_cert' | translate}}</div>
                            <div class="col-10">{{selectedSSL.ssl_cert}}</div>
                          </div>
                        </div>
                        <div class="row justify-content-end mt-2 mr-3">
                          <div class="col-2">
                            <button type="button" (click)="downloadSSLCert()"
                                    class="btn btn-primary btn-sm">
                              <i class="fa fa-download"></i>
                              <span class="d-none d-md-inline">{{'common.download' | translate}}</span>
                            </button>
                          </div>
                        </div>
                        <div class="spinner" *ngIf="!(selectedSSL && selectedSSL.ssl_key && selectedSSL.ssl_key)">
                          <div class="bounce1"></div>
                          <div class="bounce2"></div>
                          <div class="bounce3"></div>
                        </div>
                      </div>
                    </div>
                  </div>

                  <div *ngIf="ssl.get('is_update').value" class="text-center">
                    <div class="row">
                      <label class="col-3">{{'object.ssl.ssl_key' | translate}}</label>
                      <input type="file" class="col-8" placeholder="{{'object.ssl.ssl_key' | translate}}"
                             formControlName="ssl_key_file" (change)="readFile(i, $event, 'ssl_key')"/>
                    </div>
                    <div class="row text-left">
                      <span class="text-danger col-12 pl-4"
                            *ngIf="ssl.get('ssl_key_file').touched && ssl.get('ssl_key_file').invalid">{{'error.validate.input_required' | translate}}</span>
                    </div>
                    <hr>
                    <div class="row">
                      <label class="col-3">{{'object.ssl.ssl_cert' | translate}}</label>
                      <input type="file" class="col-8" placeholder="{{'object.ssl.ssl_cert' | translate}}"
                             formControlName="ssl_cert_file" (change)="readFile(i, $event, 'ssl_cert')"/>
                    </div>
                    <div class="row text-left">
                      <span class="text-danger col-12 pl-4"
                           *ngIf="ssl.get('ssl_cert_file').touched && ssl.get('ssl_cert_file').invalid">{{'error.validate.input_required' | translate}}</span>
                    </div>
                  </div>
                </td>
                <td class="text-center">
                  <div class="btn-group">
                    <button *ngIf="!ssl.get('is_update').value" (click)="onEdit(i)" [disabled]="isEditing"
                            type="submit"
                            class="btn btn-success btn-sm">
                      <i class="icon-pencil"></i>
                      <span class="d-none d-md-inline">{{'common.edit' | translate}}</span>
                    </button>
                    <button *ngIf="ssl.get('is_update').value" (click)="save(i)" type="submit"
                            [disabled]="ssl.invalid"
                            class="btn btn-primary btn-sm">
                      <i class="icon-pencil"></i>
                      <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                    </button>
                    <button *ngIf="!ssl.get('is_update').value" type="submit" (click)="remove(deleteModal, i)"
                            [disabled]="isEditing"
                            class="btn btn-danger btn-sm">
                      <i class="icon-trash"></i>
                      <span class="d-none d-md-inline">{{'common.delete' | translate}}</span>
                    </button>
                    <button *ngIf="ssl.get('is_update').value" type="submit" (click)="onCancelEdit(i)"
                            class="btn btn-danger btn-sm">
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                    </button>
                  </div>
                </td>
              </tr>
              </tbody>
            </table>
          </form>
          <div class="row justify-content-between" *ngIf="ssls && ssls.length > 0">
            <span class="col-6">{{'common.pagingInfo' | translate : {
                start: paging.offset + 1,
                end: (paging.offset + ssls.length),
                total: paging.total
            } }}</span>

            <div class="col-6">
              <ngb-pagination class="float-right" [boundaryLinks]="true" [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              (pageChange)="loadPage(paging.page)" [disabled]="isEditing">
              </ngb-pagination>
            </div>
          </div>
          <div *ngIf="!ssls || ssls.length === 0" class="text-center">
            <span>{{'common.no_record' | translate}}</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'object.ssl.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'object.ssl.delete_popup.message' | translate: {name: selectedSSL.ssl_name} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger"
            (click)="modal.close('delete')">{{'common.delete' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>

<ng-template #saveModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-save-title">{{'object.ssl.save_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'object.ssl.save_popup.message' | translate}}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('save')">{{'common.save' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>
